<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section
            class="column no-wrap q-pb-none"
            style="flex-grow: 1"
          >
            <div
              class="text-subtitle1 q-mb-sm"
            >
              <translate>Summary of parameters:</translate>
            </div>
          </q-card-section>

          <q-scroll-area class="full-width full-height q-mt-md">
            <q-list class="bg-grey-2">
              <!-- target -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                  key="plot"
                >
                  <translate>Plot</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.target.name }}
                </q-item-section>
              </q-item>

              <q-separator />

              <!-- crop -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Crop</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.plant_species.name }}
                </q-item-section>
              </q-item>

              <!-- profile -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Profile</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.plant_species_profile.profile_name }}
                </q-item-section>
              </q-item>

              <q-separator />

              <!-- irrigation -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Irrigation</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.irrigation_method.label }}
                </q-item-section>
              </q-item>

              <q-separator />

              <!-- previous campaign -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Previous crop</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.previous_plant_species.name }}
                </q-item-section>
              </q-item>

              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Residues collected</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.previous_fraction_residues != null ? 100 - Number($store.state.fertilizationPlan.parameters.previous_fraction_residues) + ' %' : '100 %' }}
                </q-item-section>
              </q-item>

              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Residues incorporated</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.previous_incorporate_residues_with_tillage ? $gettext('Yes') : $gettext('No') }}
                </q-item-section>
              </q-item>

              <q-separator />

              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Target yield</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.yield + $gettext('kg/ha') }}
                </q-item-section>
              </q-item>

              <q-separator />

              <!-- strategy -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Strategy</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.parameters.strategy.label }}
                </q-item-section>
              </q-item>
            </q-list>
          </q-scroll-area>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                @click="onClickCompute"
                :loading="computing"
              >
                <translate>Compute plan</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilicalcMixin from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/mixins/FertilicalcMixin'
import FertilicalcComputeMixin from 'src/pages/fieldbook/fertilization/algorithms/fertilicalc/mixins/FertilicalcComputeMixin'

export default {
  name: 'FertilicalcComputePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilicalcMixin, FertilicalcComputeMixin],
  data () {
    return {
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Compute')
    },
    pageSubTitle () {
      return 'FertiliCalc'
    }
  },
  methods: {
    async onClickCompute () {
      const results = await this.computeNPKRecommendation()
      if (results != null) {
        this.updateParameter('results', results)
        this.$router.push({
          name: 'fertilicalcNPKResults'
        })
      }
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'fertilicalcNitrogen'
      })
    }
  }
}
</script>
